import { IResponseError } from './Common';

/**
 *  The communication type that should be used to relay the verification code.
 */
export enum VerifyType {
    /**
     * Send code via an automated phone call.
     */
    Voice,

    /**
     * Send code via a standard text message.
     */
    SMS,
}

/**
 *  The request parameters for generating an verification code.
 */
export interface IGenerateCodeRequest {
    /**
     *  The phone number to use to send the verification code.
     *  The API will attempt to convert the value provided to an E.164 standardized number.
     */
    phoneNumber: string;

    /**
     *  The requested communication type for the {@link phoneNumber} provided.
     */
    verificationType: VerifyType;

    /**
     *  If true, the endpoint will regenerate a new code and send it to the client.
     *  If false or not provided, the original code (if one exists) will be used.
     */
    resendCode?: boolean;
}

/**
 *  The response object returned after generating and sending a verification code.
 */
export interface IGenerateCodeResponse extends IResponseError {
    /**
     *  True if the code was supplied to the user; false if the request failed.
     */
    isSent: boolean;

    /**
     *  The 2-Factor Authentication ephemeral string that should be sent in the
     *  {@link IVerifyCodeRequest.challengeId} field.
     */
    challengeId: string;
}

/**
 *  The request object for checking the validity of a verification code.
 */
export interface IVerifyCodeRequest {
    /**
     *  The 2-Factor Authentication ephemeral string that was provided by a call
     *  to {@link sendGenerateCodeRequest}.
     */
    challengeId: string;

    /**
     *  The verification code provided by the user. The value provided here, along
     *  with the {@link challengeId} will be used to confirm that the 2FA was
     *  successful.
     */
    verificationCode: string;
}

/**
 *  The response object that identifies if a verification request succeeded or
 *  failed.
 */
export interface IVerifyCodeResponse extends IResponseError {
    /**
     *  True if the verification challenge succeeded; otherwise, false.
     */
    isValid: boolean;
}

/**
 * Generates an ephemeral code and sends it to a phone number using one of the
 * {@link VerifyType} options provided.
 *
 * @param request the request parameters to use.
 * @return IGenerateCodeResponse the result of the operation including the
 * verification code and challenge id.
 */
export const sendGenerateCodeRequest = async (
    request: IGenerateCodeRequest
): Promise<IGenerateCodeResponse> => {
    try {
        const response = await fetch('/api/auth/generate', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
            },
            body: JSON.stringify(request),
        });

        if (response.ok) {
            return (await response.json()) as IGenerateCodeResponse;
        } else {
            const errorMessage = await response.text();

            return {
                challengeId: '',
                isSent: false,
                errorCode: response.status,
                errorMessage: errorMessage,
            };
        }
    } catch (e) {
        return {
            challengeId: '',
            isSent: false,
            errorCode: 500,
            errorMessage: e.toString(),
        };
    }
};

/**
 * Performs a basic lookup to see if the verification code provided matches
 * the one generated by the server.
 *
 * @param request the request parameters to use.
 * @return IVerifyCodeResponse the result of the operation including if the
 * verification succeeded or failed.
 */
export const verifyCodeRequest = async (
    request: IVerifyCodeRequest
): Promise<IVerifyCodeResponse> => {
    try {
        const response = await fetch('/api/auth/verify', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
            },
            body: JSON.stringify(request),
        });

        if (response.ok) {
            return (await response.json()) as IVerifyCodeResponse;
        } else {
            const errorMessage = await response.text();

            return {
                isValid: false,
                errorCode: response.status,
                errorMessage: errorMessage,
            };
        }
    } catch (e) {
        return {
            isValid: false,
            errorCode: 500,
            errorMessage: e.toString(),
        };
    }
};
